-- Load init.lua
import "PrimePlugins.RaidTools"

-- Don't touch this if you do not know why this is here
if not(Turbine.Language.EnglishGB == Turbine.Engine.GetLanguage() or Turbine.Language.English == Turbine.Engine.GetLanguage()) then 
    ChatOutput("Set your client to english")
    return
end

-- Create reloader
Reload = Reloader()

-- Retrieve plugin version and settings
PluginVersion = plugin:GetVersion()
--UpdateSettings() 
SetScale()
SwapWeapons = LoadTable(Turbine.DataScope.Character, "PrimeSwapData")

-- Load windows
import "PrimePlugins.RaidTools.WindowManager"

-- Set the unload events
plugin.Unload = function() 
    WindowsHandlerController:UnloadWindowEvents()

    if not(Settings.NoUnload) then PluginsManager:UnloadAllPlugins() end

    -- Save data
    SaveData()
    LootHandler:SaveLootData()
    StatEventHandling:Unload()
    Profiles:SaveSettings()
end

-- We have succesfully (re)loaded the plugin
if Settings.ReloadData then 
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." reloaded.</rgb>") 
else
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." loaded.</rgb>") 
end