function MoveWindow(mode)
    countdownWindow:ToggleMove()

    for key, value in pairs(BuffWindowObjects) do
        value:ToggleMove()
    end
    if targetBox then targetBox:ToggleMove() end
    if KillTracker ~= nil then KillTracker:ToggleMove() end ---
    if PVPCDTracker ~= nil then PVPCDTracker:ToggleMove() end --
    if Target ~= nil then Target:ToggleMove() end ---
    --if Settings.REnabled then ratTracker:ToggleMove(); end
    if messageWindow then messageWindow:ToggleMove(); end ---
    if effectsWindow then effectsWindow:ToggleMove(); end ---
    if skillCounters then skillCounters:ToggleMove(); end -- 
    if logWindow then logWindow:ToggleMove(); end ---
    if combatTimer then combatTimer:ToggleMove(); end --
    if skillTimers then skillTimers:ToggleMove(); end --
    if activeTimers then activeTimers:ToggleMove(); end --
    --if tablelength(SkillAlerts.PlayerEffects[Player:GetClass()]) > 0 then skillWindow:ToggleMove(); end --
    if(mode) then
        if Settings.LEnabled then 
            if(not logWindow:IsVisible())then
                logWindow:SetVisible(not logWindow:IsVisible())
            end
        end
    else
        if Settings.LEnabled then
            if(logWindow:IsVisible())then
                logWindow:SetVisible(false)
            end
        end
    end
end

function MoveTimers()
    if combatTimer then combatTimer:ToggleMove(); end --
    if skillTimers then skillTimers:ToggleMove(); end --
    if activeTimers then activeTimers:ToggleMove(); end --
    if skillCounters then skillCounters:ToggleMove(); end -- 
    if PVPCDTracker ~= nil then PVPCDTracker:ToggleMove() end
    for key, value in pairs(BuffWindowObjects) do
        value:ToggleMove()
    end
    --if tablelength(SkillAlerts.PlayerEffects[Player:GetClass()]) > 0 then skillWindow:ToggleMove(); end
end

function MoveWindows(mode)
    if targetBox then targetBox:ToggleMove() end
    if logWindow then logWindow:ToggleMove(); end
    if messageWindow then messageWindow:ToggleMove(); end
    if effectsWindow then effectsWindow:ToggleMove(); end
    if Target ~= nil then Target:ToggleMove() end
    if KillTracker ~= nil then KillTracker:ToggleMove() end
    countdownWindow:ToggleMove()
    if(mode) then
        if Settings.LEnabled then 
            if(not logWindow:IsVisible())then
                logWindow:SetVisible(not logWindow:IsVisible())
            end
        end
    else
        if Settings.LEnabled then
            if(logWindow:IsVisible())then
                logWindow:SetVisible(false)
            end
        end
    end
    for key, value in pairs(BuffWindowObjects) do
        value:ToggleMove()
    end
end

function MoveActionBars()
    if ActiveSkillBars then
        for _, value in pairs(ActiveSkillBars) do
            value:ToggleMove()
        end
    end
    if Settings.SkillbarPopups then SkillPopups:ToggleMove() end
end

function MoveBuffWindows()
    for key, value in pairs(BuffWindowObjects) do
        value:ToggleMove()
    end
end

MoveSettingsController = class(Turbine.UI.Control)
function MoveSettingsController:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(90 - 2, 40 - 2)
    SingleBackground:SetSize(220 + 4, 300 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(90, 40)
    SingleBackground:SetSize(220, 300)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    DescriptionLabel:SetText("Move Single Windows")
    DescriptionLabel:SetPosition(90, 40)
    DescriptionLabel:SetSize(220, 30)

    SortedNames = {}
    for key, value in pairs(Windows) do table.insert( SortedNames, key ) end
    table.sort( SortedNames )

    local index = 0
    for key, value in pairs(SortedNames) do
        if Windows[value].ToggleMove then
            local MoveButton = Turbine.UI.Lotro.Button()
            MoveButton:SetParent(self)
            MoveButton:SetText(value)
            MoveButton:SetPosition(100, index * 20 + 75)
            MoveButton:SetSize(200, 20)
            MoveButton.Click = function()
                Windows[value]:ToggleMove()
            end

            index = index + 1
        end
    end

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Skill Overlays")
    MoveButton:SetPosition(100, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveActionBars()
    end

    index = index + 1

    -- Move all buttons
    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(390 - 2, 40 - 2)
    SingleBackground:SetSize(220 + 4, 140 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(390, 40)
    SingleBackground:SetSize(220, 140)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    DescriptionLabel:SetText("Move Window Sets")
    DescriptionLabel:SetPosition(390, 40)
    DescriptionLabel:SetSize(220, 30)

    index  = 0

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Move Actionbars")
    MoveButton:SetPosition(400, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveActionBars()
    end

    index = index + 1

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Move All")
    MoveButton:SetPosition(400, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveWindow()
    end

    index = index + 1

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Move Buff Bars")
    MoveButton:SetPosition(400, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveBuffWindows()
    end

    index = index + 1

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Move Timers")
    MoveButton:SetPosition(400, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveTimers()
    end

    index = index + 1

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetText("Move Windows")
    MoveButton:SetPosition(400, index * 20 + 75)
    MoveButton:SetSize(200, 20)
    MoveButton.Click = function()
        MoveWindows()
    end

    index = index + 1

    self.MoveAll = true
    
end