E = {}

-- All effect added alerts {duration, message, iconInitial, icon, countdown, soundeffect}
E.EffectsAdded = {
    --["Hemorrhage - 3"] = {10, "Applied hemorrhage tier 3, swap aggro", false, false},
    ["Immolated"] = {3, Wounds, CureIcon, false, SoundEffects["Beepq"]},
    ["Lingering Frost"] = {2, "Puddle!", PuddleIcon, false, SoundEffects["Horn"]}, -- TG puddles
    --["Dread"] = {10, "Test", false, false},
    
    -- Anvil
    ["Flight"] = {45, "PURPLE EYE!", PurpleEye, true, SoundEffects["Run"]},
    ["Clinging Frost"] = {60, "Ice drake debuff care",  true, SoundEffects["Alarmq"]},
    ["Vethúg's Revenge"] = {15, Puddle, PuddleIcon, true, SoundEffects["Horn"]},
    ["Frozen Solid"] = {30, "Frozen", true, SoundEffects["Beeps"]},
    
    -- PVMP
    ["Blight"] = {3,"Blight", PuddleIcon, false, SoundEffects["Beepq"]}, -- defiler
    --["Inspiriting Presence"] = {10, "Cappy crit", nil, true, SoundEffects["Amazing"]},

    -- Great Barrows
    ["Dissolving"] = {3, "Move out of puddle!!", true, false, SoundEffects["AlarmQ"]},
    ["Virulent Disease"] = {3, "Move out of puddle!!", true, false, SoundEffects["AlarmQ"]},
    ["Terrifying Wind"] = {3, "Move out of puddle!!", true, false, SoundEffects["AlarmQ"]},

    -- Woe of the Willow
    ["Poisoned Earth"] = {3, "Move out of puddle!", true, false, SoundEffects["AlarmQ"]},
    ["Wrathful Roots"] = {3, "Move out of puddle!", true, false, SoundEffects["AlarmQ"]},

    -- Narrowdelve
    ["Flaming Ground"] = {3, "Move out of puddle!", true, false, SoundEffects["AlarmQ"]},
    ["Strike Point"] = {3, "Move out of puddle!", true, false, SoundEffects["AlarmQ"]},
    ["Bright Flare"] = {3, "Cleanse in water!", true, false, SoundEffects["AlarmQ"]},

    -- Spring festival
    --["Boiling Blood"] = {15, "Puddles dropping on: ", true, false, SoundEffects["AlarmQ"]},
    
    

    -- Fornost
    ["Burning Oil"] = {3, "Move out of Fire!", true, false, SoundEffects["AlarmQ"]},

    -- Carn Dum
    ["Faltering Resolve"] = {3, "Kill add to lose debuff!", true, false, SoundEffects["AlarmQ"]},    

    --["Water-lore"] = {15, "Parasites on you!", true, true, nil},

    -- Sammath Gul
    ["Burning"] = {3, "Cure Wound!", true, false, SoundEffects["Hornq"]},
    ["Harrassing Spirit"] = {15, "Major Debuff!", false, false, SoundEffects["AlarmQ"]},
    ["Slow Burn"] = {10, "Move Away From Group!", false, false, SoundEffects["AlarmQ"]},
    ["Immolation"] = {3, "Move out of flame!", false, false, SoundEffects["AlarmQ"]},
    ["Running Scared"] = {10, "Feared", false, 10, SoundEffects["AlarmQ"]},
    ["Acidic Flame"] = {3, "Move out of Green Flame! Follow it!", false, false, SoundEffects["AlarmQ"]},
    
    -- Warg Pens
    --["Lethargy"] = {3, "Cure Debuff in Campfire!", true, false, SoundEffects["Hornq"]},

}-- All effect added alerts {duration, message, iconInitial, icon, countdown, soundeffect}

--[[
RemovedBasicPlayerEffectsSelf = LoadTable(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsSelf")
AddedCharPlayerEffectsSelf = LoadTable(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsSelf")

if AddedCharPlayerEffectsSelf ~= nil then
    for key, value in pairs(AddedCharPlayerEffectsSelf) do
        E.EffectsAdded[key] = value
    end
else
    AddedCharPlayerEffectsSelf = {}
end

if RemovedBasicPlayerEffectsSelf ~= nil then
    for key, _ in pairs(RemovedBasicPlayerEffectsSelf) do
        E.EffectsAdded[key] = nil
    end
else
    RemovedBasicPlayerEffectsSelf= {}
end
--]]

-- [1] Duration [2] Message [3] Icon (Special/Game/None) [4] Countdown [5] SoundEffect [6] TargetBox popup [7] TargetBox Icon
E.AllEffectsAdded = {
    ["Crushing Roots"] = {4, "Root dot on: ", true, false, SoundEffects["Beeps"], true, HealIcon}, -- Thuringwaith tree dot
    ["Flight"] = {45, "Purple eye on: ", PurpleEyeSmall, true, nil, false, nil}, -- Anvil eye
    ["Vethúg's Revenge"] = {15, "Dot on: ", true, true, nil, true, true}, -- Anvil dot
    ["Clinging Frost"] = {4, "Frost debuff on: ", nil, true, SoundEffects["Doubleq"], false, nil}, -- Anvil debuff
    ["Frozen Solid"] = {4, "Frozen: ", nil, true, nil, false, nil}, -- Anvil frozen
    ["Scorching Rage"] = {15, "Dot on: ", PuddleIconSmall, true, SoundEffects["Doubleq"], true, true}, -- Black lore dot
    ["Blood-burst"] = {9, "Aura on: ", true, true, SoundEffects["Doubleq"], true, true}, -- Thuringwaith aura
    ["Touch of Sorcery"] = {11, "Aoe on: ", PurpleEyeSmall, true, SoundEffects["Doubleq"], false, nil}, --Throne aoe eye
    ["Shadow of Doubt"] = {9, "Puddle on: ", PuddleIconSmall, true, nil, false, nil}, --Thuringwraith puddle fear

    ["Non-Threatening"] = {5, "Threat wipe on: ", AlertIconSmall, true, SoundEffects["Doubleq"], false, nil},
    ["Hideous Venom"] = {3, "DoT on: ", AlertIconSmall, false, nil, true, true},
    ["Creeping Cold"] = {3, "DoT on: ", AlertIconSmall, false, nil, true, true},
    ["Spiteful Words"] = {3, "DoT on: ", AlertIconSmall, false, SoundEffects["Alarmq"], true, true},
    ["Blind Hatred"] = {4, "Green eye on: ", PurpleEyeSmall, false, SoundEffects["Alarmq"], true, true},
    ["Arcing Lightning"] = {15, "Lightning on: ", true, true, nil, false, nil},
    ["Sticky Venom"] = {30, "Venom on: ", AlertIconSmall, true, nil, false, nil},
    ["Fiery Combustion"] = {15, "Fiery Combustion on: ", true, true, nil, true, true},
    ["Fixated"] = {45, "Fixated on: ", AlertIconSmall, true, nil, true, true},
    ["Life Drain"] = {8, "Life Drain on: ", BloodBoilIcon, true, nil, true, BloodBoilIcon},
    ["Shadow-spun Webs"] = {8, "Binding webs on: ", WebIcon, false, nil, false, nil},
    --["Hail of Webs"] = {6, "Webs on: ", AlertIconSmall,  false, nil},
    ["Smouldering Wrath"] = {15, "Wrath on: ", true, true, nil, true, true},
    ["Dripping Ichor"] = {15, "Puddle on: ", true, true, nil, false, nil},
    ["Parasites"] = {15, "Parasites on: ", true, true, nil, true, true},
    --["Mending Verse"] = {15, "Test", AlertIconSmall, true, nil},
    --["Daughter's Phermones"] = {65, "Daughter's Phermones on: ", AlertIconSmall, true, nil},
    --["Thossulun's Phermones"] = {65, "Daughter's Phermones on: ", AlertIconSmall, true, nil}
    --["Water-lore"] = {4, "Water-lore on: ", true, true, nil},

    -- Great Barrows
    ["Lurking Sickness"] = {15, "Cure disease on: ", true, 15, nil, true, true},

    -- Garth Agarwen (spring festival)
    ["Grievous Wound"] = {3, "Cure Wound on: ", true, false, nil, true, true},

    -- Narrow Delve
    ["Battered and Bruised"] = {3, "Cure wound on: ", true, 3, SoundEffects["Alarmq"], true, true},
    ["Vicious Bite"] = {3, "Cure wound on: ", true, 3, nil, true, true},
    ["Fear of the Witch-King"] = {3, "Cure fear on: ", true, 3, nil, true, true},
    ["Vengeance of the Fallen"] = {3, "Cure fear on: ", true, 3, nil, true, true},
    ["Spirit Wrack"] = {3, "Cure fear on: ", true, 3, nil, true, true},
    ["Howling Winds"] = {3, "Cure fear on: ", true, 3, nil, true, true},
    ["Freezing!"] = {5, "Frozen! Drop fire on: ", AlertIconSmall, false, SoundEffects["Alarmq"], true, true},

    -- Fornost
    ["Serious Wound"] = {3, "Cure wound on: ", true, false, nil, true, true},

    -- Barad Guluran
    ["Distraught"] = {3, "Cure Fear on: ", true, false, nil, true, true},
    ["Affliction through Shadow"] = {10, "Cure Fear ASAP on: ", true, 10, nil, true, true},
    ["Affliction through Flame"] = {10, "Cure Wound ASAP on: ", true, 10, nil, true, true},

    -- Urugarth
    ["Chilled"] = {3, "Cure Fear on: ", true, false, nil, true, true},

    -- Carn Dum
    ["Impaled"] = {3, "Impale(root) on: ", true, false, nil, true, true},
    
    

    -- Helegrod
    ["Fatal Poison"] = {15, "Cure poison ASAP on: ", true, 15, nil, true, true},
    ["Baleful Eye"] = {15, "Cure fear ASAP on: ", true, 15, nil, true, true},

    -- Nala Dum
    ["Deadly Acid"] = {3, "Cure Poison on!: ", true, false, nil, false, nil}, 

    -- Roots of Fangorn


    --PvMP
    ["Field Promotion"] = {4, "Bubble on: ", true, false, nil, false, nil},
    ["Grievous Wounds"] = {5, "Grave wound on: ", true, true, nil, true, true},
    ["Oathbreaker's Shame"] = {20, "OB on: ", true, true, nil, true, true},
    ["Heart Seeker"] = {8, "HS on: ", true, true, nil, true, true},
    ["Essence of Winter"] = {5, "Essence of Winter on: ", true, false, nil, false, nil},
    --["Telling Mark"] = {3, "Telling Mark on: ", nil, false, nil},
    --["Blessing of Darkness"] = {4, "Blessing on: ", nil, false, nil},
    ["Ancient Craft"] = {5, "AC on: ", true, false, nil, true, true},
    ["Shadow Vortex"] = {10, "Vortex on: ", true, true, nil, false, nil},
    ["Impending End"] = {20, "Free: ", true, true, nil, false, nil},

    ["Rowdy Crowd"] = {12, "Volleys on: ", true, true, nil, false, nil},
    ["Massive Javelin"] = {7, "Javelin on: ", true, true, nil, false, nil},
    ["Gorgar's Target"] = {4, "Charge on: ", true, true, nil, false, nil},

    ["Frost Trap"] = {6, "Frost trap on: ", true, false, nil, false, nil},
    ["Combust"] = {6, "Combust on: ", true, false, nil, false, nil},
    --["Bloody Wound"] = {60, "Bloody Wound on: ", true, true, SoundEffects["tauntBoss"], false, nil}
}
-- [1] Duration [2] Message [3] Icon (Special/Game/None) [4] Countdown [5] SoundEffect [6] TargetBox popup [7] TargetBox Icon

--[[
RemovedBasicPlayerEffectsAll = LoadTable(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsAll")
AddedCharPlayerEffectsAll = LoadTable(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsAll")

if AddedCharPlayerEffectsAll ~= nil then
    for key, value in pairs(AddedCharPlayerEffectsAll) do
        E.AllEffectsAdded[key] = value
    end
else
    AddedCharPlayerEffectsAll = {}
end

if RemovedBasicPlayerEffectsAll ~= nil then
    for key, _ in pairs(RemovedBasicPlayerEffectsAll) do
        E.AllEffectsAdded[key] = nil
    end
else
    RemovedBasicPlayerEffectsAll= {}
end
--]]

-- Self buffs only
-- [1] duration [2] name [3] unique [4] activity timer [5] show activity
E.SelfOnlyEffects = {
    ["Inspiriting Presence"] = {30, "Cappy crit", false, 10, true},
}

-- Self buffs only
-- [1] duration [2] name [3] unique [4] activity timer [5] show activity
EBeorning = {
    ["Nature's Bond"] = {120, "Nature's Bond", true, 20, true},
    ["Thickened Hide"] = {120, "TH", false, true, true},
    ["Aid the Assault"] = {38.5, "Maul", false, 8.5, true}
}
EBrawler = {}
EBurglar = {}
ECaptain = {
    --["Last Stand"] = {300 , "Last Stand (Max)", false, nil},
    ["Last Stand"] = {75 , "LS (Min)", false, 17, true},
    ["In Harm's Way"] = {180, "IHW", true, 15, true},
    ["Fighting Withdrawal"] = {60, "Withdrawal", true, 20, true},
    ["Cry of Vengeance"] = {300, "Captain rez", true, nil, nil},
}
EChampion = {
    --["Champion's Duel 1"] = {60, "Champs duel", false}
}
EGuardian = {
    ["Warrior's Heart"] = {120, "WH", true, 20, true},
    ["Guardian's Pledge"] = {120, "Pledge", false, 15, true},
    ["Juggernaut"] = {180, "Juggernaut", true, 15, true},
    ["Bring on the Pain"] = {60, "TOD", false, 10, true},
    ["Litany of Defiance"] = {90, "Litany", false, 20, true},
    ["Break Ranks"] = {60, "Break Ranks", true, 15, true}
}
EHunter = {}
ELoreMaster = {}
EMinstrel = {
    ["Recovering Spirit"] = {45, "Triumphant Spirit", false, nil},
    ["Fellowship's Heart"] = {120, "Fellowship's Heart", true, nil},
    ["Legend of the Hammerhand"] = {120, "AOE Mini bubble", true, nil}
}
ERuneKeeper = {
    ["Our Fates Entwined"] = {90, "Fates", true, 20, true},
}
EWarden = {}
EBlackArrow = {
    ["Moving Target"] = {90, "MT", true, true, true}
}
EDefiler = {
    ["Blessing of Darkness"] = {80, "Blessing", true, nil}
}
EReaver = {}
EStalker = {
    ["Sprint"] = {90, "Sprint", false, true, true},
    ["Improved Stealth"] = {210, "Dissappear", false, true, true}
}
EWarleader = {}
EWeaver = {
    ["Toxic Carapace"] = {60, "Reflect", false, true, true}
}


E.PlayerEffects = {
    [Turbine.Gameplay.Class.Beorning] = EBeorning,
    [Turbine.Gameplay.Class.Brawler] = EBrawler,
    [Turbine.Gameplay.Class.Burglar] = EBurglar,
    [Turbine.Gameplay.Class.Captain] = ECaptain,
    [Turbine.Gameplay.Class.Champion] = EChampion,
    [Turbine.Gameplay.Class.Guardian] = EGuardian,
    [Turbine.Gameplay.Class.Hunter] = EHunter,
    [Turbine.Gameplay.Class.LoreMaster] = ELoreMaster,
    [Turbine.Gameplay.Class.Minstrel] = EMinstrel,
    [Turbine.Gameplay.Class.RuneKeeper] = ERuneKeeper,
    [Turbine.Gameplay.Class.Warden] = EWarden,
    [Turbine.Gameplay.Class.BlackArrow] = EBlackArrow,
    [Turbine.Gameplay.Class.Defiler] = EDefiler,
    [Turbine.Gameplay.Class.Reaver] = EReaver,
    [Turbine.Gameplay.Class.Stalker] = EStalker,
    [Turbine.Gameplay.Class.WarLeader] = EWarleader,
    [Turbine.Gameplay.Class.Weaver] = EWeaver
}

RemovedBasicSkillTimersSpecific = LoadTable(Turbine.DataScope.Character, "PrimeRemovedSkillTimersSpecific")
AddedCharSkillTimersSpecific = LoadTable(Turbine.DataScope.Character, "PrimeAddedSkillTimersSpecific")

if Settings.SpecificEffectAlertToken == nil or Settings.SpecificEffectAlertToken < 2 then
    RemovedBasicSkillTimersSpecific = {}
    AddedCharSkillTimersSpecific = {}
    Settings.SpecificEffectAlertToken = 2
    ChatOutput("Reset custom specific effect alerts due to versioning")
end

if AddedCharSkillTimersSpecific ~= nil then
    for key, value in pairs(AddedCharSkillTimersSpecific) do
        for key2, value2 in pairs(value) do
            E.PlayerEffects[key][key2] = value2
        end
    end
else
    AddedCharSkillTimersSpecific = {}
end

if RemovedBasicSkillTimersSpecific ~= nil then
    for key, value in pairs(RemovedBasicSkillTimersSpecific) do
        for key2, value2 in pairs(value) do 
            E.PlayerEffects[key][key2] = nil
        end
    end
else
    RemovedBasicSkillTimersSpecific= {}
end


E.AllPlayerEffects = {
    -- Beorning Group Buffs
    ["Sacrifice"] = {60, "Sacrifice (Min)", false, 20, true},
    -- Cappy Group Buffs
    ["Standard of Valour Incoming Healing Buff"] = {60, "Banner", true, 30, true},
    ["Standard of War Damage Buff"] = {60, "Banner", true, 30, true},
    ["Standard of Honour"] = {60, "Banner", true, 30, true},
    -- RuneKeeper group buffs
    ["Essay of Exaltation"] = {45, "AOE RK Bubble", true, nil},
    --["Word of Exaltation"] = {45, "AOE RK Bubble", true, nil},
    ["Shield of the Dúnedain"] = {120 , "SoD", false, true, true},
    -- PvMP
    ["Field Promotion"] = {120, "Bubble", false, true, true},
    --["Parasites"] = {40, "Parasites", false, nil, false},

    -- Test
    --["Mending Verse"] = {15, "Test", false, true, true},
    --["Water-lore"] = {39, "Test", false, true, true},
    --["Temporary State Immunity"] = {20, "Test", false, true, true},
    --["Fertile Slime"] = {20, "Test", false, true, true},
    --["Charge!"] = {20, "Test", false, true, true},
}

RemovedBasicSkillTimersAll = LoadTable(Turbine.DataScope.Character, "PrimeRemovedSkillTimersAll")
AddedCharSkillTimersAll = LoadTable(Turbine.DataScope.Character, "PrimeAddedSkillTimersAll")

if Settings.AllEffectAlertToken == nil or Settings.AllEffectAlertToken < 2 then
    RemovedBasicSkillTimersAll = {}
    AddedCharSkillTimersAll = {}
    Settings.AllEffectAlertToken = 2
    ChatOutput("Reset custom all effect alerts due to versioning")
end

if AddedCharSkillTimersAll ~= nil then
    for key, value in pairs(AddedCharSkillTimersAll) do
        E.AllPlayerEffects[key] = {value[1], value[2], value[3], value[4], value[5]}
    end
else
    AddedCharSkillTimersAll = {}
end

if RemovedBasicSkillTimersAll ~= nil then
    for key, _ in pairs(RemovedBasicSkillTimersAll) do
        E.AllPlayerEffects[key] = nil
    end
else
    RemovedBasicSkillTimersAll= {}
end


-- [1] duration [2] alert [3] icon [3] icon (true/false)
E.SkillNames = {
    --["Gaze of Sauron"] = {4, "Purple eye!", PurpleEyeSmall, true}
    ["Shadow Force"] = {45, "AoE CD", nil, true},
    ["Bursting Flame"] = {3, "Move in melee range!", nil, false},
    ["Baleful Roar"] = {3, "Check for hope", nil, false},
    ["Bone Grind"] = {3, "Move out of Bone Grind", nil, false},
    ["Cave In"] = {3, "Move out of Cave In", nil, false},
    ["Poisoned Ground"] = {2, "Move out!", nil, false},
    ["Killing Field"] = {2, "Move out!", nil, false},
    ["Disintegration"] = {2, "Move out!", nil, false},
    ["Whirlwind"] = {2, "Move out!", nil, false},
    ["Withering Strike"] = {3, "Don't forget to interrupt!", nil, false},
    ["Stinger Thrust"] = {3, "Stinger Thrust!", nil, false},
    ["Ultimate Scorched Earth"] = {3, "Interrupt knockback!", nil, false}, 
    ["Shock Wave"] = {3, "Avoid floor effects!", nil, false},
    ["Desecrated Ground"] = {2, "Move out!", nil, false},
    --["Bleeding Ears"] = {30, "REFLECT!! REFLECT!! REFLECT!!", DarknessIcon, true},
    ["Flame Jet"] = {3, "Avoid floor flames!!", nil, false},  
}

E.SkillAlertNames = {
}

E.UniqueEffects = {
    ["Necrotic Ooze"] = true
}

E.GroupEffectsActive = {
    ["Standard of Valour Incoming Healing Buff"] = true,
    ["Standard of War Damage Buff"] = true,
    ["Standard of Honour"] = true,
    ["Our Fates Entwined"] = true,
}

E.GroupEffectsCooldown = {
    ["Standard of Valour Incoming Healing Buff"] = true,
    ["Standard of War Damage Buff"] = true,
    ["Standard of Honour"] = true,
    ["Our Fates Entwined"] = true,

    ["Sacrifice"] = true,
    ["Essay of Exaltation"] = true,
    ["Shield of the Dúnedain"] =true,
    ["Field Promotion"] = true,
    ["Legend of the Hammerhand"] = true,
    ["Fellowship's Heart"] = true,
    ["Nature's Bond"] = true,



    --["Mending Verse"] = true,


}

E.BetterEffectIcons = {
    ["Our Fates Entwined"] = 1091829845,
    ["Essay of Exaltation"] = 1091829850,

    ["Juggernaut"] = 1091805299,
    ["Litany of Defiance"] = 1091444826,
    ["Bring on the Pain"] = 1090541184,

    ["In Harm's Way"]  = 1091926677,

    ["Recovering Spirit"] = 1091810072,
    ["Legend of the Hammerhand"] = 1091830292,


}

TargetWindowEffects = {  
    -- Test
    --["Defiant Challenge"] = "Test message",
    --["Conviction"] = "Test message",
    --["In the Fray"] = true,
    --["Assailment"] = true,
    --["Man-form"] = true,
    --["Hearten"] = true,
    --["Blood of Fire"] = true,
    --["Mending Verse"] = true,
    --
    -- Shelob
    ["Pained Determination"] = true,
    --["Wilful Determination"] = "Phial",

    -- Thossulun
    ["Penetrated Shell"] = true,

    -- Shadowed King
    ["Shadow's Protection"] = true,
    ["Crushed"] = true,

    -- Rift
    ["Vulnerable"] = true,

    -- DN
    ["Vigor"] = true,
    ["Frenzy"] = true,

    -- Class Freep
    ["Ancient Craft"] = true,
    ["Oathbreaker's Shame"] = true,
    ["Oaths Fulfilled"] = true,
    ["Grievous Wounds"] = true,
    ["Moving Target"] = true,
    ["Field Promotion"] = true,
    ["Knives Out"] = true,
    ["Shield of the Dúnedain"] = true,
    ["Last Stand"] = true,
    ["Our Fates Entwined"] = true,
    ["Subtle Stab"] = true,
    ["Do Not Fall This Day"] = true,
    ["Clinging Webs"] = true,
    ["Entangling Web"] = true,
    ["Venomous Haze"] = true,
    ["Essence of Winter"] = true,

    -- Class Creep
    ["Toxic Carapace"] = true,
    ["Sprint"] = true,
    ["Blight"] = true,
    ["Festering Wound"] = true,
    ["Blessing of Darkness"] = true,
    --["Blinding Dust"] = true,
    ["Sundering Blow"] = true,
    ["Hamstrung"] = true,
    ["Blade Toss"] = true,
    ["Devastating Strike"] = true,


    -- CC immunities
    ["Daze and Stun Immunity"] = true,
    ["Root Immunity"] = true,
    ["Fear Immunity"] = true,
    ["Immunity"] = true,
    ["Temporary State Immunity"] = true,
    ["Continuous Blood Rage"] = true,
    ["Juggernaut"] = true,
    ["Tactically Sound"] = true,

    --PVP Server
    ["Invulnerable"] = true,
    --["Fire"]

    -- Hiddenhoard
    ["Guardian's Defiance"] = true,
    ["Retaliation"] = true,
}

function SetEffects()
    local PlayerClass = Player:GetClass() 
    -- Freeps
    if PlayerClass == Turbine.Gameplay.Class.Beorning then
        TargetWindowEffects["Defensive Blow"] = true
        TargetWindowEffects["Debilitating Bees"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Burglar then
        TargetWindowEffects["Reveal Weakness"] = true 
    elseif PlayerClass == Turbine.Gameplay.Class.Captain then
        TargetWindowEffects["Armour Rend"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Guardian then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        --TargetWindowEffects["Disable"]
    elseif PlayerClass == Turbine.Gameplay.Class.LoreMaster then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        TargetWindowEffects["Shatter Arms"] = true
        TargetWindowEffects["Ranged Critical Chance"] = true
        TargetWindowEffects["Nature's Light"] = true
        TargetWindowEffects["Benediction of the Raven"] = true
        TargetWindowEffects["Charged Air"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper then
        TargetWindowEffects["Writ of Lightning"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Warden then
        TargetWindowEffects["Low Bleed - Quick Sweep"] = true
        TargetWindowEffects["Medium Bleed - Quick Sweep"] = true
        TargetWindowEffects["Marked Target"] = true
        TargetWindowEffects["Diminished Target"] = true
        TargetWindowEffects["Hampering Javelin"] = true
    -- Creeps
    elseif PlayerClass == Turbine.Gameplay.Class.BlackArrow then
        TargetWindowEffects["Hindering Shot"] = true
    end
end

StackingTargetEffects = {
    -- Rukhor
    ["Blood-Infused - "] = 10,
    ["Blood Drain - "] = 10,
    -- Shelob
    ["Impenetrable Webs - "] = 120,
    -- Guruthang of the Queensbrood.
    ["Elusive - "] = 5,
    --["Coward's Fate "] = 5,

    -- Bukky
    ["Warlord's Wrath - "] = 10,
}

for key, value in pairs(StackingTargetEffects) do
    for i = 1, value do 
        TargetWindowEffects[key .. i] = true
    end
end

RemovedBasicEffects = LoadTable(Turbine.DataScope.Character, "PrimeRemovedTargetEffects")
AddedCharEffects = LoadTable(Turbine.DataScope.Character, "PrimeAddedTargetEffects")

if AddedCharEffects ~= nil then
    for key, _ in pairs(AddedCharEffects) do
        TargetWindowEffects[key] = true
    end
else
    AddedCharEffects = {}
end

if RemovedBasicEffects ~= nil then
    for key, _ in pairs(RemovedBasicEffects) do
        TargetWindowEffects[key] = nil
    end
else
    RemovedBasicEffects = {}
end



function AddTableToTable(table1, table2)
    if table1 and table2 then
        for key, _ in pairs(table1) do
            table2[key] = true
        end
    end
end

GroupEffectsLUT = {}
SelfEffectsLUT = {}

-- Get all effects in one table

ReadyCheckTable = {
    ["Duty Bound"] = true,
    ["Ironfold Edhelharn Token: Give Hope"] = true,
    --["Ironfold Edhelharn Token: Give Hope"] = true,
    ["Minas Ithil Warding Lore"] = true,
}

-- Self

AddTableToTable(ReadyCheckTable, SelfEffectsLUT)

if Settings.SPEnabled then
    AddTableToTable(E.AllPlayerEffects, SelfEffectsLUT)
    for key, value in pairs(E.PlayerEffects) do
        AddTableToTable(value, SelfEffectsLUT)
    end
    AddTableToTable(E.SelfOnlyEffects, SelfEffectsLUT)
end

if Settings.SEnabled then
    AddTableToTable(TEffects, SelfEffectsLUT)
end

if Settings.EEnabled then
    AddTableToTable(E.EffectsAdded, SelfEffectsLUT)  
end

if Settings.AEnabled then
    AddTableToTable(E.AllEffectsAdded, SelfEffectsLUT)
end

-- Group
AddTableToTable(ReadyCheckTable, GroupEffectsLUT)

if Settings.AEnabled then
    GroupEffectsLUT["Do Not Fall This Day"] = true
    AddTableToTable(E.AllEffectsAdded, GroupEffectsLUT)
end

if Settings.SPEnabled then
    AddTableToTable(E.AllPlayerEffects, GroupEffectsLUT)
    for key, value in pairs(E.PlayerEffects) do
        AddTableToTable(value, GroupEffectsLUT)
    end
end

if Settings.SEnabled then
    AddTableToTable(TAllEffects, GroupEffectsLUT)
end

-- Collect all damage triggers

DamageLUT = {}

AddTableToTable(TDamage, DamageLUT)
AddTableToTable(E.SkillNames, DamageLUT)
AddTableToTable(E.SkillAlertNames, DamageLUT)
DamageLUT["Steadfast Barrage"] = true

PvPTimerTriggers = {
    ["Steadfast Barrage"] = 30,
    ["Moving Target"] = 90,
    ["Defiant Challenge"] = 30,
    ["Toxic Carapace"] = 60,
    ["Sprint"] = 90,
    ["Trap and Run"] = 30,
}

ShowExpiryEffects = {
    -- PvE

    -- Shelob
    ["Pained Determination"] = true,

    -- Shadowed kings
    ["Shadow's Protection"] = true,
    ["Crushed"] = true,

    -- Freep effects
    ["Oathbreaker's Shame"] = true,
    ["Knives Out"] = true,
    ["Shield of the Dúnedain"] = true,
    ["Last Stand"] = true,

    ["Fire-lore"] = true,
    ["Frost-lore"] = true,
    ["Shatter Arms"] = true,
    ["Ranged Critical Chance"] = true,
    ["Nature's Light"] = true,
    ["Benediction of the Raven"] = true,

    ["Defensive Blow"] = true,
    ["Debilitating Bees"] = true,

    ["Marked Target"] = true,
    ["Diminished Target"] = true,
    ["Hampering Javelin"] = true,

    ["Do Not Fall This Day"] = true,

    -- CC immunities
    ["Daze and Stun Immunity"] = true,
    ["Root Immunity"] = true,
    ["Fear Immunity"] = true,
    ["Immunity"] = true,
    ["Temporary State Immunity"] = true,
    ["Continuous Blood Rage"] = true,
    ["Juggernaut"] = true,
    ["Tactically Sound"] = true,

    -- PvP

    -- Creep effects
    ["Moving Target"] = true,
    ["Field Promotion"] = true,
    ["Toxic Carapace"] = true,

    ["Hindering Shot"] = true,
}