--effectsWindow:Message(10, "Test", GondorTreeIcon, false)

--messageWindow:Message(5, "To enable sound effects you have to", nil, false)
--messageWindow:Message(5, "start logging your main chat window!", nil, false)

--[[
local backPack = Player:GetBackpack()

for i = 1, backPack:GetSize(), 1 do
    local item1 = backPack:GetItem(i)
    if item1 ~= nil then 
        local item = item1:GetItemInfo()
        ChatOutput(item:GetName() .. item:GetIconImageID()) 
    end
end
--]]

--[[
local effectList = Player:GetEffects()

local PlayerEffects = {}
for i = 1, effectList:GetCount(), 1 do
    PlayerEffects[effectList:Get(i):GetName()] = true
    ChatOutput(effectList:Get(i):GetName() .. " " .. effectList:Get(i):GetIcon())
end 
--]]
--for key, value in pairs(Turbine) do
--    ChatOutput(key)
--end

-- [[
local tskills = Player:GetTrainedSkills()

for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
    local item = tskills:GetItem(i)--:GetSkillInfo()
    ChatOutput(item:GetSkillInfo():GetName() .. " - " .. item:GetSkillInfo():GetIconImageID())       

end
--]]


--[[
for key, value in pairs(TestTable) do
    ChatOutput(ConvertEntry(key))
    ChatOutput(RecoverEntry(ConvertEntry(key)))
    ChatOutput(ConvertEntry(value))
    ChatOutput(RecoverEntry(ConvertEntry(value)))
end
--]]

--[[
TODO:
Cleanup dungeon log code
Add daily/weekly quests to loot window

Need Testing:
Cleanup loot window code -- Needs Testing
Add first time use setup/tutorial -- Needs testing
Increase raid command permissions -- Needs testing
Finish pvp timers -- Needs testing
Skilloverlay click on skill fix -- Needs testing

DONE:
Add swap commands to prime help -- DONE
]]

--[[
TestWindow = class(Turbine.UI.Window)
function TestWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetPosition(500, 500)
    self:SetSize(400, 400)
    self:SetBackColor(GetRandomColour())

    local TargetSelections = {}

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(400, 400)
    container:SetPosition(0, 0)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(false)

    local EControl = Turbine.UI.Lotro.EntityControl()
    EControl:SetParent (self)
    EControl:SetVisible (true)
    EControl:SetPosition (200, 200)
    EControl:SetSize(100, 100)
    EControl:SetEntity(Player)
    EControl:SetBackColor(GetRandomColour())

    Player.TargetChanged = function()
        if Player:GetTarget() ~= nil then 

            local listItem = Turbine.UI.Control()
            listItem:SetVisible(true)
            listItem:SetSize( 100, 15 )

            local E = Turbine.UI.Lotro.EntityControl()
            E:SetParent (listItem)
            E:SetVisible (true)
            E:SetSize(100, 15)
            E:SetEntity(Player:GetTarget())
            E:SetBackColor(GetRandomColour())


            container:AddItem( listItem )


            TargetSelections[Player:GetTarget():GetName()] = Player:GetTarget()
        end
        for key, value in pairs(TargetSelections) do
            ChatOutput(key .. " " .. value:GetName())
        end
        ChatOutput(tablelength(TargetSelections))
        ChatOutput(EControl:GetEntity():GetName())
    end
end

--t = TestWindow()

--]]


--[[
TestWindow = class(Turbine.UI.Control)
function TestWindow:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.Targets = {}
    self.TargetsFunction = {}

    Player.TargetChanged = function()

        ChatOutput("X")
        if Player:GetTarget() ~= nil then
            local target = Player:GetTarget()
            target.MoraleChanged = function()
                ChatOutput("Y")
            end
            self.Targets[Player:GetTarget():GetName()] = target
            self.TargetsFunction[Player:GetTarget():GetName()] = target.MoraleChanged
        end
    end

    self.Update = function()
        for key, value in pairs(self.Targets) do
            --ChatOutput(key)
            --ChatOutput(value:GetMorale())

        end
    end

    self:SetWantsUpdates(true)

end

TestWindow()
--]]
--[[
TestViewer = class(Turbine.UI.Window)
function TestViewer:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 1024
    self.height = 1024
    self:SetPosition(0, 0)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetBackground(0x411F9DFA) --0x41000912 ice --0x411AE441 blood --0x41142E03  0x4114B070
    self:SetStretchMode(1)
    self:SetSize(1920, 1080)
    self:SetOpacity(1)
    self:SetWantsKeyEvents(true)

    self.startingID = 1092592681--1092591217
     --self:SetBackground(self.startingID)

    self.KeyDown = function(sender, args)
        if args["Action"] == 268435468 then
            self.startingID = self.startingID + 1
            ChatOutput(self.startingID)
                self:SetBackground(self.startingID)
        end
    end
    self:SetWantsUpdates(true)

    self.LastUpdate = 0

    self.Update = function()

            self.startingID = self.startingID + 1
            ChatOutput(self.startingID)
            self:SetBackground(self.startingID)
    end

end

x = TestViewer()
--]]

TestViewer = class(Turbine.UI.Window)
function TestViewer:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 1000
    self.height = 1000
    self:SetPosition(200, 200)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetVisible(true)
    self:SetMouseVisible(false)
    --self:SetBackground(0x411F9DFA) --0x41000912 ice --0x411AE441 blood --0x41142E03  0x4114B070
    --self:SetStretchMode(1)
    --self:SetSize(1920, 1080)
    --self:SetOpacity(1)
    --self:SetWantsKeyEvents(true)
    

    
    for i = 1, 1, 1 do
        local show = Turbine.UI.Control()
        show:SetParent(self)
        show:SetSize(32, 32)
        show:SetBackColor(Turbine.UI.Color(1, 0, 0))
        show:SetBackground(SkullIcon)
        show:SetPosition(50 * i, 32)
        show:SetBackColorBlendMode(3) -- alphablend
        show:SetBlendMode(4)
    end

    local show = Turbine.UI.Control()
    show:SetParent(self)
    --show:SetSize(16, 16)
    show:SetBackColor(Turbine.UI.Color(1, 0, 0))
    show:SetBackground(SkullIcon)
    show:SetStretchMode(2)
    ChatOutput(show:GetWidth())
    show:SetPosition(50 * 2, 32)
    show:SetBackColorBlendMode(3) -- alphablend
    show:SetBlendMode(4)

    local show = Turbine.UI.Control()
    show:SetParent(self)
    show:SetSize(16, 16)
    show:SetBackColor(Turbine.UI.Color(1, 0, 0))
    show:SetBackground(SkullIcon)

    ChatOutput(show:GetWidth())
    show:SetPosition(50 * 3, 32)
    show:SetBackColorBlendMode(3) -- alphablend
    show:SetBlendMode(4)

    local show = Turbine.UI.Control()
    show:SetParent(self)
    show:SetSize(16, 16)
    show:SetBackColor(Turbine.UI.Color(1, 0, 0))
    show:SetBackground(SkullIcon)
    show:SetStretchMode(2)
    ChatOutput(show:GetWidth())
    show:SetPosition(50 * 4, 32)
    show:SetBackColorBlendMode(3) -- alphablend
    show:SetBlendMode(4)

    local show = Turbine.UI.Control()
    show:SetParent(self)
    show:SetSize(16, 16)
    show:SetBackColor(Turbine.UI.Color(1, 0, 0))
    show:SetBackground(SkullIcon)
    show:SetStretchMode(2)
    show:SetStretchMode(1)
    show:SetSize(160, 160)
    show:SetPosition(50 * 5, 32)
    show:SetBackColorBlendMode(3) -- alphablend
    show:SetBlendMode(4)
    ChatOutput(show:GetWidth())
    --[[

    self.highlight = ClassSpecificTools.HighlightFrame2(self, 3)
    self.highlight:Toggle(true)

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(32,32)
    self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    --self.IconLabel:SetAllowDrop(false)
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(32, 32)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetPosition(-2, -2)

    --self.fMLabel = ClassSkillLabel(self, 0, 0, base, base, CJIconSmalll, true)

    self.IconLabel.ShortcutChanged = function()
        --self.IconLabel:SetShortcut(self.shortcut)
        ChatOutput(self.IconLabel:GetShortcut():GetData())
    end
    --]]

    --self:SetStretchMode(1)
    --self:SetSize(800, 800)

    --[[
    self.overlap = Turbine.UI.Control()
    self.overlap:SetParent( self.ring )
    self.overlap:SetVisible(false)
    self.overlap:SetMouseVisible(false)
    self.overlap:SetSize(128, 128)
    --self.overlap:SetBlendMode(1)
    self.overlap:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    --self.overlap:SetPosition(300, 300)
    self.overlap:SetBackColor(Turbine.UI.Color(1,0,0,0))

    self.overlap2 = Turbine.UI.Window()
    self.overlap2:SetParent(self.ring)
    self.overlap2:SetVisible(true)
    self.overlap2:SetMouseVisible(false)
    self.overlap2:SetPosition(0, 0)
    self.overlap2:SetSize(256, 256)
    self.overlap2:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    --self.overlap2:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
    --self.overlap:SetPosition(300, 300)
    self.overlap2:SetBackColor(Turbine.UI.Color(1,0,0,0))
    for key, value in pairs(self.overlap2:GetRotation())do
        ChatOutput(key)
        ChatOutput(value)
    end

    self.overlap2:SetRotation({x=0, y=0, z=45})
    --]]
    
    --self.overlap:SetBackColor

    --[[
    self.elapsedOverlay = Turbine.UI.Control()
    self.elapsedOverlay:SetParent( self.ring )
    self.elapsedOverlay:SetVisible(true)
    --self.elapsedOverlay:SetStretchMode( 1 )
    self.elapsedOverlay:SetMouseVisible( false )
    --self.elapsedOverlay:SetOpacity(0.3)
    --self.elapsedOverlay:SetZOrder( 99 )
    self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0) )
   -- self.elapsedOverlay:SetBlendMode(1)
    --self.elapsedOverlay:SetBackColorBlendMode(7)
    --self.elapsedOverlay:SetPosition(120, 0)
    self.elapsedOverlay:SetSize(32, 32)
    self.elapsedOverlay:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.elapsedOverlay:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
    --self.elapsedOverlay:SetSize( 256, 256)
    --self.elapsedOverlay:SetStretchMode(3)
    --self.elapsedOverlay:SetPosition(100, 100)

    self:SetWantsUpdates(false)

    local backgroundIndex = 0
    local lastUpdate = Turbine.Engine.GetGameTime()
    self.Update = function()

        if lastUpdate + 0.05 < Turbine.Engine.GetGameTime() then
            lastUpdate = Turbine.Engine.GetGameTime()

            backgroundIndex = (backgroundIndex + 1) % 60
            local background = 0x41007E35 + backgroundIndex
            --ChatOutput(background)
            self.ring:SetStretchMode(3)
            self.elapsedOverlay:SetSize( 32, 32 )
            self.elapsedOverlay:SetBackground( background )
            --self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
            --self.elapsedOverlay:SetPosition(120, 0)
            --self.elapsedOverlay:SetStretchMode(0)
            --self:SetWantsUpdates(false)
            
            self.ring:SetStretchMode(1)
            --self.elapsedOverlay:SetBlendMode(1)
            --self.elapsedOverlay:SetBackColorBlendMode(7)
            self.ring:SetSize(40, 40)
        end
    end
    --]]

    --ClassSpecificTools.HighlightFrame3(self, 100, 100, 128, 128)
end

x = TestViewer()

--ID: 0x41007DC7; Size: 32 × 32; Appeared in: Update 12.0 or before


--ChatOutput(plajer:GetClassAttributes():GetStance())

-- Yellow
-- 0x41007F09
-- 0x41007F0D

-- WHite
-- 0x41007F0E
-- 0x41007F15

-- Green
-- 0x41007F15
-- 0x41007F35

-- SMoke
-- 0x41007F22
-- 0x41007F2B

-- Flash
-- 0x41007F18
-- 0x41007F21

-- Item 1
-- 0x4112958B
-- 0x411295F7

-- Item 2
-- 0x411296D1
-- 0x411296E7